export declare abstract class DataSource<T> {
    abstract getRows(): Promise<T[]> | T[];
}
export default DataSource;
export interface IEditable<T> {
    add(newData: T): void;
    update(rowId: string, newData: T): void;
    delete(rowId: string): void;
}
export declare abstract class EditableDataSource<T> extends DataSource<T> implements IEditable<T> {
    abstract add(newData: T): void;
    abstract update(rowId: string, newData: T): void;
    abstract delete(rowId: string): void;
}
