"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t;
    return { next: verb(0), "throw": verb(1), "return": verb(2) };
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var React = require("react");
var header_1 = require("./header");
exports.Header = header_1.default;
var row_1 = require("./row");
exports.Row = row_1.default;
exports.Column = row_1.Column;
var datasource_1 = require("./datasource");
exports.DataSource = datasource_1.DataSource;
exports.EditableDataSource = datasource_1.EditableDataSource;
var util_1 = require("../lib/util");
/**
 * Base Table class
 *
 * Since React doesn't allow type parameters to be set in jsx, i'd suggest the creation of a custom class which extends this base class and includes a type parameter
 * @export
 * @class Table
 * @extends {React.Component<ITableProps<T>, Partial<ITableState>>}
 * @template T
 */
var Table = (function (_super) {
    __extends(Table, _super);
    function Table(props) {
        var _this = _super.call(this) || this;
        _this.state = {
            rows: []
        };
        _this.setSort = _this.setSort.bind(_this);
        if (props.dataSource) {
            _this.getData(props);
        }
        return _this;
    }
    Table.prototype.getData = function (props) {
        return __awaiter(this, void 0, void 0, function () {
            var tRows;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, props.dataSource.getRows()];
                    case 1:
                        tRows = _a.sent();
                        this.setState({
                            rows: tRows
                        });
                        return [2 /*return*/];
                }
            });
        });
    };
    Table.prototype.render = function () {
        var _this = this;
        var tGridSize = this.props.gridSize || 12;
        var tClasses = [
            'table',
            'container',
            this.props.className
        ];
        var tHeaderColumnClasses = [
            this.props.headerColumnClassName,
            this.props.addClassesToHeader !== false ? this.props.columnClassName : ''
        ];
        var tHeaderClasses = [
            this.props.headerClassName,
            this.props.addClassesToHeader !== false ? this.props.rowClassName : ''
        ];
        var tData = this.props.data || this.state.rows;
        if (this.state.sortField) {
            tData = tData.sort(function (a, b) {
                var tAField = a[_this.state.sortField];
                var tBField = b[_this.state.sortField];
                var tSortedFieldConfig = _this.props.fieldConfig[_this.state.sortField];
                var tSortFactor = _this.state.sortDir === 'asc' ? 1 : -1;
                if (tSortedFieldConfig.sortFunction) {
                    return tSortedFieldConfig.sortFunction(tAField, tBField, tSortFactor);
                }
                var tSort;
                if (typeof (tAField) === 'string') {
                    tSort = tAField.localeCompare(tBField);
                }
                else if (typeof (tAField) === 'number') {
                    tSort = tAField - tBField;
                }
                else {
                    tSort = 1;
                }
                return tSortFactor * tSort;
            });
        }
        return (React.createElement("div", { className: tClasses.join(' ') },
            React.createElement(header_1.default, { sortField: this.state.sortField, sortDir: this.state.sortDir, sortable: this.props.sortable, key: 'header', data: this.props.fieldConfig, className: util_1.combineClasses(tHeaderClasses), columnClassName: util_1.combineClasses(tHeaderColumnClasses), filteredClassName: this.props.filteredColumnClassName, onColumClick: this.setSort }),
            tData.map(function (entry, index) {
                var tKey = tData[index][_this.props.primaryKey] || index;
                return React.createElement(row_1.default, { key: tKey, sortField: _this.state.sortField, rowKey: tKey, data: entry, config: _this.props.fieldConfig, className: _this.props.rowClassName, columnClasses: _this.props.columnClassName, filteredColumnClasses: _this.props.filteredColumnClassName, onColumnClick: function (rowKey, columnKey) {
                        if (_this.props.onRowSelected) {
                            _this.props.onRowSelected(rowKey);
                        }
                        if (_this.props.onCellClick) {
                            _this.props.onCellClick(rowKey, columnKey);
                        }
                    } });
            })));
    };
    Table.prototype.setSort = function (key) {
        if (this.props.fieldConfig[key].sortable === false) {
            return;
        }
        if (key !== this.state.sortField) {
            return this.setState({
                sortField: key,
                sortDir: this.state.sortDir === undefined ? 'asc' : this.state.sortDir
            });
        }
        this.setState({
            sortDir: this.state.sortDir === 'asc' ? 'desc' : 'asc'
        });
    };
    return Table;
}(React.Component));
exports.Table = Table;
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = Table;
//# sourceMappingURL=index.js.map