"use strict";
var React = require("react");
var util_1 = require("../lib/util");
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = function (props) {
    var tRowClasses = [
        'row',
        props.className
    ];
    var tProps = Object.getOwnPropertyNames(props.config);
    var tColumns = tProps
        .filter(function (prop) {
        var tConfig = props.config[prop];
        if (tConfig && !tConfig.hidden) {
            return true;
        }
        return false;
    })
        .sort(function (a, b) {
        var tAConfig = props.config[a];
        var tBConfig = props.config[b];
        return (tAConfig.order || 0) - (tBConfig.order || 0);
    })
        .map(function (prop) {
        var tConfig = props.config[prop];
        if (tConfig.hidden) {
            return '';
        }
        var tColumnClasses = [props.columnClasses];
        if (props.sortField === prop) {
            tColumnClasses.push(props.filteredColumnClasses);
        }
        return React.createElement(Column, { key: prop, config: tConfig, value: props.data[prop], className: util_1.combineClasses(tColumnClasses), rowKey: props.rowKey, columnKey: prop, onColumnClick: function (columnKey) {
                if (props.onColumnClick) {
                    props.onColumnClick(props.rowKey, columnKey);
                }
            } });
    });
    // if (props.actions) {
    // 	tColumns.push(<Column
    // 		key={'actions'}
    // 		config={{}}
    // 		columnKey={'actions'}
    // 		rowKey={props.rowKey}
    // 		value={}
    // 	/>);
    // }
    return React.createElement("div", { className: util_1.combineClasses(tRowClasses) }, tColumns);
};
;
function Column(props) {
    var tColumnClasses = [
        'col',
        props.className,
        props.config.size ? "col-" + props.config.size : null
    ];
    var tValue = props.config.getCell ? props.config.getCell(props.rowKey, props.value) : props.value;
    return React.createElement("div", { className: util_1.combineClasses(tColumnClasses), onClick: function () {
            if (props.onColumnClick) {
                props.onColumnClick(props.columnKey);
            }
        } }, tValue);
}
exports.Column = Column;
//# sourceMappingURL=row.js.map