import * as React from 'react';
// import './dropdown.scss';
export class Dropdown extends React.Component {
    constructor(props) {
        super();
        this.state = {
            selected: props.selected,
            open: false
        };
        this.toggle = this.toggle.bind(this);
        this.onChange = this.onChange.bind(this);
        document.getElementsByTagName('body')[0].addEventListener('click', this.closeHandler);
    }
    componentWillUnmount() {
        document.getElementsByTagName('body')[0].removeEventListener('click', this.closeHandler);
    }
    closeHandler(ev) {
        if (this.state && this.state.open) {
            this.setState({
                open: false
            });
        }
    }
    render() {
        let tOptions = this.props.options.map((option) => {
            let tValue = option.formatValue ? option.formatValue(option) : option.value;
            return React.createElement("div", { className: option.className, key: option.key, onClick: this.onChange.bind(this, option.key), dangerouslySetInnerHTML: { __html: tValue } });
        });
        let tValue = '';
        if (this.state.selected && this.props.options.find((option) => {
            return option.key === this.state.selected.key;
        })) {
            tValue = this.state.selected.value;
        }
        else {
            tValue = 'Bitte auswählen';
            this.setState({
                selected: null
            });
        }
        let tOpen = this.state.open ? 'open' : '';
        return (React.createElement("div", { className: 'dropdown ' + tOpen },
            this.props.label ?
                React.createElement("label", null, this.props.label) : '',
            React.createElement("div", { className: 'value', onClick: this.toggle },
                tValue,
                React.createElement("i", { className: 'fa fa-angle-down' })),
            React.createElement("div", { className: 'drop' }, tOptions)));
    }
    toggle() {
        this.setState({
            open: !this.state.open
        });
    }
    onChange(key) {
        let tElement = this.props.options.find((option) => {
            return option.key === key;
        });
        if (this.props.onChange) {
            if (this.props.name) {
                this.props.onChange(this.props.name, tElement);
            }
            else {
                this.props.onChange(tElement);
            }
        }
        this.setState({
            selected: tElement,
            open: false
        });
    }
}
//# sourceMappingURL=index.js.map