var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
import * as React from 'react';
import { combineClasses } from '../lib/util';
class Input extends React.Component {
    constructor() {
        super();
        this.submit = this.submit.bind(this);
    }
    render() {
        return (React.createElement("div", { className: combineClasses(this.props.containerClassName) },
            this.props.label ?
                React.createElement("label", { className: combineClasses(this.props.labelClassName) }, this.props.label)
                : '',
            React.createElement("input", __assign({}, this.props, { onKeyDown: this.submit }))));
    }
    submit(ev) {
        if (ev.which === 13 && this.props.onSubmit) {
            ev.preventDefault();
            let tEvent = {
                target: ev.target
            };
            this.props.onSubmit(tEvent);
        }
    }
}
export default Input;
export class InputWithOptions extends React.Component {
    constructor() {
        super();
        this.state = {
            options: []
        };
        this.onInput = this.onInput.bind(this);
        this.onChange = this.onChange.bind(this);
    }
    render() {
        let tOptions = this.state.options.map((option) => {
            return React.createElement("div", { key: option.key, onClick: this.onChange.bind(this, option.key), "data-key": true }, option.value);
        });
        let tOpen = tOptions.length > 0 ? ' open' : '';
        return (React.createElement("div", { className: 'InputWithOptions' },
            this.props.label ?
                React.createElement("label", null, this.props.label)
                : '',
            React.createElement("input", __assign({ className: 'mb-standard' }, this.props, { onInput: this.onInput })),
            React.createElement("div", { className: 'drop' + tOpen }, tOptions)));
    }
    onInput(val) {
        if (val) {
            if (this.timer) {
                window.clearTimeout(this.timer);
            }
            this.timer = window.setTimeout(() => {
                if (this.props.getOptions) {
                    this.timer = null;
                    this.props.getOptions(val).then((data) => {
                        this.setState({
                            options: data
                        });
                    });
                }
            }, 200);
        }
        else {
            window.clearTimeout(this.timer);
            this.timer = null;
            this.setState({
                options: []
            });
        }
    }
    onChange(key) {
        this.setState({
            options: []
        });
        if (this.props.onChange) {
            this.props.onChange(key);
        }
    }
}
//# sourceMappingURL=index.js.map