import Table, { DataSource } from '../index';
import * as React from 'react';
import { shallow } from 'enzyme';
const fieldConfig = {
    id: {
        hidden: true
    },
    name: {
        header: 'Name'
    },
    age: {
        order: -1
    }
};
class TestDataObject {
}
class TestDataSource extends DataSource {
    constructor() {
        super(...arguments);
        this.data = [
            Object.assign(new TestDataObject(), { id: 'aid', name: 'aname', age: 0 }),
            Object.assign(new TestDataObject(), { id: 'bid', name: 'bname', age: 1 }),
            Object.assign(new TestDataObject(), { id: 'cid', name: 'cname', age: 2 })
        ];
    }
    getRows() {
        return this.data;
    }
}
class TestTable extends Table {
}
describe('Table with DataSource', () => {
    const tTable = shallow(React.createElement(TestTable, { dataSource: new TestDataSource(), primaryKey: 'id', fieldConfig: fieldConfig }));
    it('has 1 row', () => {
        expect(tTable.children().length).toEqual(1);
    });
});
//# sourceMappingURL=dataSourceTable.js.map